/*******************************************************************************
 * Copyright (c) 2016 1C-Soft LLC.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Vladimir Piskarev (1C) - initial API and implementation
 *******************************************************************************/
package model.impl;

import org.eclipse.core.resources.IResourceDelta;

import model.IHElement;
import model.IHElementDelta;
import model.IHElementDeltaMirror;

/**
 * TODO JavaDoc
 */
public abstract class HElementDeltaBase
    implements IHElementDelta, IHElementDeltaImpl
{
    private ResourceDeltaContainer resourceDeltaContainer;

    @Override
    public IHElement hElement()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public int hKind()
    {
        // TODO Auto-generated method stub
        return 0;
    }

    @Override
    public long hFlags()
    {
        // TODO Auto-generated method stub
        return 0;
    }

    @Override
    public IHElementDelta[] hAffectedChildren()
    {
        return IHElementDelta.EMPTY_ARRAY;
    }

    @Override
    public IResourceDelta[] hResourceDeltas()
    {
        if (resourceDeltaContainer == null)
            return ResourceDeltaContainer.NO_RESOURCE_DELTAS;
        return resourceDeltaContainer.resourceDeltas;
    }

    @Override
    public void hAddResourceDelta(IResourceDelta resourceDelta)
    {
        if (resourceDeltaContainer == null)
            resourceDeltaContainer = new ResourceDeltaContainer();
    }

    @Override
    public IHElementDeltaMirror hMirror()
    {
        if (this instanceof IHElementDeltaMirror)
            return (IHElementDeltaMirror)this;
        else
            return new IHElementDeltaMirror()
            {
                @Override
                public IHElementDelta hDelta()
                {
                    return HElementDeltaBase.this;
                }
            };
    }

    private static class ResourceDeltaContainer
    {
        static final IResourceDelta[] NO_RESOURCE_DELTAS =
            new IResourceDelta[0];

        IResourceDelta[] resourceDeltas;
    }
}
